/*
 * Infra Red protocols decoder
 * Author: Piotr Wjtowicz
 * 2016-2017
 * pw@elportal.pl
 */

#ifndef IRDECODER_H_INCLUDED
#define IRDECODER_H_INCLUDED

#include <stdio.h>
#include <stdint.h>

#include "necdec.h"
#include "rc5dec.h"
#include "sircdec.h"

#define US2TIME(t) ((t)/64) //konwersja us na 64*us
#define EPS 1
#define MAXT 127
#define T_OVERTIME 150
//#define SIZET sm.ntrans=sizeof(outr) / sizeof(outr[0]);sm.trans=outr
#define TRDEF static const trans_t outr[]
#define TR(a,b,c,d) {a-b,a+b,c,d}
#define TROUT2(e,f) TRDEF={e,f}; sm.ntrans=2;sm.trans=outr //SIZET
#define TROUT3(g,h,i) TRDEF={g,h,i}; sm.ntrans=3;sm.trans=outr //SIZET
#define TROUT4(a,b,c,d) TRDEF={a,b,c,d}; sm.ntrans=4;sm.trans=outr //SIZET
#define TROUT5(a,b,c,d,e) TRDEF={a,b,c,d,e}; sm.ntrans=5;sm.trans=outr //SIZET
#define RET1 TR(MAXT, MAXT, 1, initsm)
#define RET0 TR(MAXT, MAXT, 0, initsm)

typedef struct  {
    uint8_t tmin;
    uint8_t tmax;
    uint8_t nextState;
    void (*next_trans) (void);
} trans_t;

typedef struct {
    const trans_t* trans;
    uint8_t ntrans;
    void (*next_trans) (void);
    uint8_t productReady : 1;
} sm_t;

extern const uint8_t sircBytesLen[];

typedef enum {
    NONE = 0, NEC, RC5_, SIRC
} protocol_type_e;

typedef struct {
    uint8_t addr;
    uint8_t cmd;
    protocol_type_e pt;
} IR_frame_t;

typedef IR_frame_t frame_ret_t;

extern frame_ret_t frame_ret;

typedef struct {
    uint8_t data[4];
    uint8_t bitCounter : 3;
    uint8_t field : 3;
    uint8_t bitValueTmp : 1;
} irsm_t;

extern irsm_t irsm;

extern sm_t sm;

void sm_facade(uint8_t t, uint8_t state);

void initsm();
void initsm();
void decoderStateH();
void decoderStateL();

extern void debug_tpls(uint8_t t);

#endif // IRDECODER_H_INCLUDED
