/* 
 * File:   switch.h
 * Author: piotrek
 *
 * Created on August 2, 2016, 9:25 PM
 */

#ifndef SWITCH_H
#define	SWITCH_H

#define MT(x) (uint8_t)(2000LL*(x)/65535) //ms to T1 overflow period
#define DEBOUNCE_TIME MT(50) //ms avoid bounce
#define LONG_PRESS MT(1500)
#define LONG_LONG_PRESS MT(3000)
#define SW_STATE_MAX LONG_LONG_PRESS+MT(5000)

typedef enum {
    SWITCH_OFF=0, SWITCH_ON, 
} switch_states_enum_t;

typedef enum {
    NONE_EVENT, SWITCH_OFF_T1, SWITCH_OFF_T2, SWITCH_PRESSED, SWITCH_ON_T1, SWITCH_ON_T2, 
            SWITCH_PULLED
} switch_events_enum_t;

typedef struct {
    uint8_t state_t; //timer for switch state
    uint8_t before_state_t;
    uint8_t deb_timer; //timer for debounce
    switch_states_enum_t before_state_s;
    switch_states_enum_t state_s;
    uint8_t eat_pulled_event: 1;
} switch_state_t;    
    
extern switch_state_t sw_sm;

void init_switch ();

inline void handle_switch ();

#endif	/* SWITCH_H */

